/*
	File:		Cyberdog.h

	Contains:	xxx put contents here xxx

	Written by:	the cyberdogs

	Copyright:	 1996 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<10>	 6/25/96	JCM		added preferred mail and news encodings pref
		 <9>	 6/25/96	mmn		add kCDHTMLTagKey
		 <8>	 6/24/96	HL		fix Cyberdog.h to work with the 68K project
		 <7>	 6/22/96	JCM		added key for preferred language
		 <6>	 6/20/96	HL		add kNotebookKindTagIntCategory
		 <5>	 6/19/96	jcr		Add kMNPrefsKind
		 <4>	 6/11/96	tb		Added kCyberICNewsPrefMaxDownload for saving the number of
									articles to download inside IC.
		 <3>	  6/4/96	jse		add EmbeddedKey for ParamSet
		 <2>	 5/30/96	jcr		Add MailStatusPart
		<14>	 5/20/96	HL		CFM-68K work
		<13>	 5/20/96	jse		1351297 - add SendOnCheck prefs string
		<12>	  5/7/96	mmn		error codes
		<11>	  4/5/96	mmn		add WindowHint and OpenerPartDestDraft key
		<10>	  4/3/96	mmn		add not resolved error
		 <9>	  4/3/96	cc		removing mail server defines
		 <8>	 3/30/96	mc		B3 fixes
		 <7>	 3/26/96	sdh		new error code
		 <6>	 3/23/96	sdh		1327668
		 <5>	 3/12/96	mmn		export GetCyberSession() & InitCyberdog()
		 <4>	  3/9/96	sdh		new IC keys
		 <3>	  3/4/96	cc		Mail Fixes and Link Warnings removed
		 <2>	 2/29/96	mc		More API Freeze

	To Do:
*/

#ifndef __CYBERDOG__
#define	__CYBERDOG__

//  Functions

#ifndef REZ

class	CyberSession;
struct 	Environment;
class 	ODSession;

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif
extern "C" pascal OSErr			InitCyberdog(Environment* ev, ODSession* session);
extern "C" pascal CyberSession*	GetCyberSession(Environment* ev);
extern "C" pascal void DoCyberdogAboutPublic(Environment* , ODSession* );
#if PRAGMA_IMPORT_SUPPORTED
#pragma import reset
#endif

#endif

//  Extension Names

#define kCyberPartExtension					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:CyberPart"
#define kCyberConnectExtension				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Connect"
#define kCyberContainerExtension			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Container"
#define kCyberFormExtension					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Form"
#define kCyberItemPromptExtension			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:CyberItemPrompt"
#define kCyberLogExtension					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Log"
#define kCyberNavigatorExtension			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Navigator"
#define kCyberNotebookExtension				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Notebook"
#define kCyberOpenerPartExtension			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:OpenerPart"
#define kCyberPrefsExtension				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Prefs"
#define kCyberProgressPartExtension			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:ProgressPart"
#define kCyberDownloadExtension				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Extension:Download"


//  Part Kinds

#define kConnectDialogKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:ConnectDialog"		// Kind
#define kDownloadPartKind 					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:DownloadPart"
#define kLogKind							"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:Log"				// Kind
#define kLogManagerKind						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:LogManager"			// Kind
#define kMailStatusPartKind 				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:MailStatus"
#define kMNPrefsDlgKind						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:MNPrefsDlg"			// Kind
#define kNavigatorKind 						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:Navigator"			// Kind
#define kNetscapePluginKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:NetscapePlugin"		// Kind
#define kNotebookKind						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:Notebook"			// Kind
#define kNotebookManagerKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:NotebookManager"	// Kind
#define kOpenerPartKind 					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:Opener"
#define kPrefsDialogKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:PrefsDialog"		// Kind
#define kTelnetPartKind						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:Telnet"	// Kind
// CyberItem Kinds
#define kCyberItemKind						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem"			// Kind
#define kCyberItemGroupKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItemGroup"		// Kind
// CyberPartKind
#define kCyberPartKind						"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberPart"			// Kind

//  Data Format Definitions


// Tags used within the kNotebookKind data format
#define kNotebookKindTagCyberItem			'cybr'
#define kNotebookKindTagCategory			'catg'
#define kNotebookKindTagIntCategory			'cati'	// category with script code

// Tags used within the kLogKind data format
#define kLogKindAlphabetical				'alph'
#define kLogKindChronological				'chrn'
#define kLogKindHierarchical				'hier'

// Signature and Version used within kCyberItemKind data format
#define kCyberItemSignature					'cy'
#define kCyberItemVersionNum				1


//  SimpleCyberService Class Name

#define kSimpleCyberServiceClassName		"SimpleCyberService"


//  Cyberdog Defined Creators

#define kCyberdogCreator			'dogz'
#define kNavigatorCreator			'dogv'


//  Cyberdog Command Numbers

#define kCDCmdRefresh 					1


//  MIME Strings and Kinds

// Strings
#define kApplicationAppleFile				"application/applefile"
#define kApplicationCompress				"application/x-compress"
#define kApplicationMacBinary				"application/macbinary"
#define kApplicationMacBinhex40				"application/mac-binhex40"
#define kApplicationOctetStream				"application/octet-stream"
#define kApplicationPostscript				"application/postscript"
#define kApplicationText					"application/text"
#define kAudioAIFF							"audio/x-aiff"
#define kAudioBasic							"audio/basic"
#define kAudioWAV							"audio/x-wav"
#define kImageGIF							"image/gif"
#define kImageJPEG							"image/jpeg"
#define kImagePICT							"image/x-pict"
#define kImageTIFF							"image/tiff"
#define kImageXBM							"image/x-xbitmap"
#define kImageXPM							"image/x-xpixmap"
#define kMessageExternalBody				"message/external-body"
#define kMessagePartial						"message/partial"
#define kMessageRFC822						"message/rfc822"
#define kMultipartAlternative				"multipart/alternative"
#define kMultipartDigest					"multipart/digest"
#define kMultipartMixed						"multipart/mixed"
#define kMultipartParallel					"multipart/parallel"
#define kTextEnriched						"text/enriched"
#define kTextHTML							"text/html"
#define kTextPlain							"text/plain"
#define kVideoAVI							"video/avi"
#define kVideoMPEG							"video/mpeg"
#define kVideoQuickTime						"video/quicktime"
// Kinds
#define kMIMEPrefix							"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:"
#define kApplicationAppleFileKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/applefile"
#define kApplicationCompressKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/x-compress"
#define kApplicationMacBinaryKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/macbinary"
#define kApplicationMacBinhex40Kind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/mac-binhex40"
#define kApplicationOctetStreamKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/octet-stream"
#define kApplicationPostscriptKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/postscript"
#define kApplicationTextKind				"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:application/text"
#define kAudioAIFFKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:audio/x-aiff"
#define kAudioBasicKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:audio/basic"
#define kAudioWAVKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:audio/x-wav"
#define kImageGIFKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:image/gif"
#define kImageJPEGKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:image/jpeg"
#define kImagePICTKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:image/x-pict"
#define kImageTIFFKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:image/tiff"
#define kImageXBMKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:image/x-xbitmap"
#define kImageXPMKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:image/x-xpixmap"
#define kMessageExternalBodyKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:message/external-body"
#define kMessagePartialKind					"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:message/partial"
#define kMessageRFC822Kind					"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:message/rfc822"
#define kMultipartAlternativeKind			"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:multipart/alternative"
#define kMultipartDigestKind				"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:multipart/digest"
#define kMultipartMixedKind					"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:multipart/mixed"
#define kMultipartParallelKind				"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:multipart/parallel"
#define kTextEnrichedKind					"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:text/enriched"
#define kTextHTMLKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:text/html"
#define kTextPlainKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:text/plain"
#define kVideoAVIKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:video/avi"
#define kVideoMPEGKind						"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:video/mpeg"
#define kVideoQuickTimeKind					"+//ISO 9070/ANSI::113722::US::CI LABS::MIME:video/quicktime"
// Reference Kinds
#define kApplicationAppleFileRefKind		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/applefile"
#define kApplicationCompressRefKind			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/x-compress"
#define kApplicationMacBinaryRefKind		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/macbinary"
#define kApplicationMacBinhex40RefKind		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/mac-binhex40"
#define kApplicationOctetStreamRefKind		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/octet-stream"
#define kApplicationPostscriptRefKind		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/postscript"
#define kApplicationTextRefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:application/text"
#define kAudioAIFFRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:audio/x-aiff"
#define kAudioBasicRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:audio/basic"
#define kAudioWAVRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:audio/x-wav"
#define kImageGIFRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:image/gif"
#define kImageJPEGRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:image/jpeg"
#define kImagePICTRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:image/x-pict"
#define kImageTIFFRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:image/tiff"
#define kImageXBMRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:image/x-xbitmap"
#define kImageXPMRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:image/x-xpixmap"
#define kMessageExternalBodyRefKind			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:message/external-body"
#define kMessagePartialRefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:message/partial"
#define kMessageRFC822RefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:message/rfc822"
#define kMultipartAlternativeRefKind		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:multipart/alternative"
#define kMultipartDigestRefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:multipart/digest"
#define kMultipartMixedRefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:multipart/mixed"
#define kMultipartParallelRefKind			"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:multipart/parallel"
#define kTextEnrichedRefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:text/enriched"
#define kTextHTMLRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:text/html"
#define kTextPlainRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:text/plain"
#define kVideoAVIRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:video/avi"
#define kVideoMPEGRefKind					"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:video/mpeg"
#define kVideoQuickTimeRefKind				"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Kind:CyberItem:MIME:video/quicktime"


//  Internet Config Keys
// All of these types must begin with an 8 character hexadecimal representation of the
// Cyberdog creator that applies to the preference, e.g. 646F677A == 'dogz'
// Do *not* define a new key when a perfectly good one appears in ICKeys.h
// ! These need some cleanup.

#define kCyberICDefaultScheme			"\p646F677ADefaultScheme"	/* PString */
#define kCyberICConnectService			"\p646F677AConnectService"	/* ODType (part kind) */
// Security
#define kCyberICEnteringSecureSpace		"\p646F677AEnterSecure"		/* Boolean */
#define kCyberICLeavingSecureSpace		"\p646F677ALeaveSecure"		/* Boolean */
#define kCyberICMixedSecureDocument		"\p646F677AMixedSecureDoc"		/* Boolean */
#define kCyberICNonSecureForm			"\p646F677ANonSecureForm"		/* Boolean */
// FTP
#define kCyberICFTPPrefShowHiddenFiles			"\p646F676FHiddenFiles"					/* Boolean */
#define kCyberICFTPPrefUniqueNameOnUpload		"\p646F676FUniqueNameOnUpload"				/* Boolean */	
#define kCyberICFTPPrefUsePassive				"\p646F676FUsePassiveMode"					/* Boolean */	
// Log
#define kCyberICLogSize					"\p646F676CLogSize"		/* UInt32 */
// Mail
#define kCyberICDistributionForPostedArticles	"\p646F676DDistributionForPostedArticles"	/* PString */
#define kCyberICMailDefaultMailboxFolder		"\p646F676DMailDefaultMailboxFolder"		/* ICFileSpec */
#define kCyberICMailPrefShowButtonsInEnvelope	"\p646F676DMailShowButtonsInEnvelope"		/* Boolean */
#define kCyberICMailPrefCloseLetterWindow		"\p646F676DMailCloseLetterWindow"			/* Boolean */
#define kCyberICMailPrefWarnWhenUnsaved			"\p646F676DMailWarnWhenUnsaved"			/* Boolean */
#define kCyberICMailLeaveMailInOutTrayChoice	"\p646F676DMailLeaveMailInOutTrayChoice"	/* Boolean, true==permanently, false==for n days */
#define kCyberICMailLeaveMailInOutTrayDays		"\p646F676DMailLeaveMailInOutTrayDays"		/* short */
#define kCyberICMailPrefExpandEnvelopeNew		"\p646F676DMailExpandEnvelopeNew"			/* Boolean */
#define kCyberICMailPrefExpandEnvelopeOpen		"\p646F676DMailExpandEnvelopeOpen"			/* Boolean */
#define kCyberICMailPrefPrintEnvelope			"\p646F676DMailPrintEnvelope"				/* Boolean */
#define kCyberICMailSendOnCheck					"\p646F676DMailSendOnCheck"				/* Boolean */
//	News
//	%%%	tjb	note, the kCyberICDistributionForPostedArticles should probably be defined here as well
//	i'm not sure of the impact of changing it yet.  also, the Notebook stuff below is using 'dogn'
//	instead of 'dogk'.  again, I'm not sure of the consequences of changing it.
//	i'll continue to use 'dogm' for the news stuff, so it doesn't conflict with the notebook stuff
#define kCyberICNewsPrefMaxDownload				"\p646F676DNewsNumberOfArticlesToDownload"	/* UInt32 */
// Notebook
#define kCyberICNotebookFile					"\p646F676ENotebookFile"					/* ICFileSpec */
// Telnet
#define kCyberICTelnetPrefTerminalEmulation		"\p646F6774TelnetTerminalEmulation"		/* PString */
#define kCyberICTelnetPrefTerminalToolName		"\p646F6774TelnetTerminalToolName"			/* PString */
#define kCyberICTelnetPrefTerminalToolConfig	"\p646F6774TelnetTerminalToolConfig"		/* TEXT */
// Web
#define kCyberICWebPrefHeadlineFont				"\p646F6777WebHeadlineFont"				/* ICFontRecord */
#define kCyberICWebPrefTextFont					"\p646F6777WebTextFont"					/* ICFontRecord */
#define kCyberICWebPrefTypewriterFont			"\p646F6777WebTypewriterFont"				/* ICFontRecord */
#define kCyberICWebPrefReadColor				"\p646F6777WebReadColor"					/* RGBColor */
#define kCyberICWebPrefUnreadColor				"\p646F6777WebUnreadColor"					/* RGBColor */
#define kCyberICWebPrefUnderlineLinks			"\p646F6777WebUnderlineLinks"				/* Boolean */
// Navigator
#define kCyberICNavigatorPrefShowControlBanner	"\p646F6776ShowControlBanner"				/* Boolean */
#define kCyberICNavigatorPrefShowLocationBanner	"\p646F6776ShowLocationBanner"				/* Boolean */
#define kCyberICNavigatorPrefTunnel				"\p646F6776Tunnel"							/* Boolean */
// Language
#define kCyberICLanguagePrefPreferredLanguage	"\p646F677APreferredLanguage"				/* TICPreferredLanguage */
#define kCyberICLanguagePrefPreferredMailEncodings	"\p646F677APreferredMailEncodings"		/* TICPreferredEncodingMap */
#define kCyberICLanguagePrefPreferredNewsEncodings	"\p646F677APreferredNewsEncodings"		/* TICPreferredEncodingMap */

//  Error Codes

#define	kCyberErrorsBase			-12000

#define kCDErrInvalidObject				(kCyberErrorsBase-0)
#define kCDErrInvalidURL				(kCyberErrorsBase-1)
#define kCDErrReserved1					(kCyberErrorsBase-2)
#define kCDErrServerBusy				(kCyberErrorsBase-3)
#define kCDErrAuthentication			(kCyberErrorsBase-4)
#define kCDErrReserved2					(kCyberErrorsBase-5)
#define kCDErrItemUnavailable			(kCyberErrorsBase-6)
#define kCDErrParamAlreadyExists 		(kCyberErrorsBase-7)
#define kCDErrNoInternetConfig			(kCyberErrorsBase-8)
#define kCDErrCyberSessionAlreadyExists	(kCyberErrorsBase-9)
#define kCDErrInvalidServiceResource	(kCyberErrorsBase-10)
#define kCDErrNoFileRepresentation		(kCyberErrorsBase-11)
#define kCDErrPasswordRetriesExceeded	(kCyberErrorsBase-12)
#define kCDErrMacTCPorOTMissing			(kCyberErrorsBase-13)
#define kCDErrItemNotResolved			(kCyberErrorsBase-14)

//  CyberProxy

#define 	kCyberProxyScheme			"cyberproxy:"


//  OpenerPartDestDraftKey, 	a ParameterSet key observed by CyberSession.ObtainOpener when creating new opener parts 
//  OpenerPartEmbeddedKey, 	a ParameterSet key used by some parts to determine if they're opening embedded in another part 
//  HTMLTagKey,				a ParameterSet key that contains the html tag and attributes when opening a display part embedded in an html page.

#define kCDOpenerPartDestDraftKey			"Apple:OpenerPartDestDraft"
#define kCDOpenerPartEmbeddedKey			"Apple:OpenerPartEmbedded"
#define kCDHTMLTagKey						"Apple:HTMLTag"

//  Window Positioning Hint 

#define kCDWindowPositionHintProperty	"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Property:WindowPositionHint"
#define kCDWindowPositionHintValue		"+//ISO 9070/ANSI::113722::US::CI LABS::Apple:Cyberdog:Value:WindowPositionHint"

#ifndef REZ

// cyberdog may add a window positioning hint to a cyberdog display part's storage unit prior to calling its part->Open method

struct CDWindowPositionHint
{
	WindowPtr 		behindWindow;	// indicates which window to open behind, a value of -1 means open in front (4 bytes)
	Point			windowPosition; // indicates where to position the window (4 bytes)
};


//	struct used to represent the preferred language
struct TICPreferredLanguage
{
	short	fCountryCode;
	short	fLanguageCode;
};

//	structs used to represent the preferred encodings for various languages
struct TICPreferredEncodingMapEntry
{
	long fScript;
	long fEncoding;
};

struct TICPreferredEncodingMap
{
	long							fNumberEntries;
	TICPreferredEncodingMapEntry	fMap[1];			//	this is really an array of fNumberEntries entries
};

#endif

#endif
