#ifndef __CYBERDOGPROCPTRS__
#define __CYBERDOGPROCPTRS__

enum CDDownloadEvent
{
	kCDDownloadSucceeded,
	kCDDownloadFailed,
	kCDDownloadCancelled,
	kCDDownloadPostProcessed
}; 

enum CDAddressField
{
	kToField = 1,
	kCCField,
	kBCCField,
	kLastField = 0xFFFFFFFF		// Force this to be a long
};

enum CDAbortProcMessage
{
	kAbortMessage
};


class	CyberProgressBroadcaster;
class 	CyberItem;
struct 	Environment;


typedef void (*CyberDownloadCompletionProcPtr)(Environment* ev,  CyberItem* item, CDDownloadEvent eventCode, FSSpec* destFile, Ptr userDataPtr);
typedef void (*CyberMenuDataDestructorProcPtr)(void* menuData);
typedef void (*CyberNotebookAddressProcPtr)(CDAddressField whichField, /* CyberItemList* */ void* cyberItemsList, Ptr userDataPtr);
typedef void (*CyberResolveCompletionProcPtr)(OSErr err, CyberItem* item, Ptr userDataPtr);
typedef void (*CyberAbortProcPtr)(CDAbortProcMessage msgCode, CyberProgressBroadcaster* broadcaster, Ptr userDataPtr);
typedef void (*ParamDestructorProcPtr)(Environment* ev, void* param);


// CyberAbortProcPtr


enum {
	uppCyberAbortProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(CDAbortProcMessage)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(Ptr)))
		 | STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(Ptr)))
};

#if GENERATINGCFM
	
	typedef UniversalProcPtr CyberAbortUPP;
	
	#define CallCyberAbortProc(userRoutine, msgCode, task, userDataPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppCyberAbortProcInfo, msgCode, task, userDataPtr)
	#define NewCyberAbortProc(userRoutine)		\
			(CyberAbortUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppCyberAbortProcInfo, GetCurrentArchitecture())

#else

	typedef CyberAbortProcPtr CyberAbortUPP;
	
	#define CallCyberAbortProc(userRoutine, msgCode, task, userDataPtr)		\
			(*userRoutine)(msgCode, (CyberProgressBroadcaster*)task, (Ptr)userDataPtr)
	#define NewCyberAbortProc(userRoutine)		\
			(CyberAbortUPP)(userRoutine)
#endif


// CyberResolveCompletionProcPtr

enum {
	uppCyberResolveCompletionProcInfo = kPascalStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(OSErr)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(Ptr)))
		 | STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(Ptr)))
};

#if GENERATINGCFM
typedef UniversalProcPtr CyberResolveCompletionUPP;

#define CallCyberResolveCompletionProc(userRoutine, err, item, userDataPtr)		\
		CallUniversalProc((UniversalProcPtr)userRoutine, uppCyberResolveCompletionProcInfo, err, item, userDataPtr)
#define NewCyberResolveCompletionProc(userRoutine)		\
		(CyberResolveCompletionUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppCyberResolveCompletionProcInfo, GetCurrentArchitecture())
#else
typedef CyberResolveCompletionProcPtr CyberResolveCompletionUPP;

#define CallCyberResolveCompletionProc(userRoutine, err, item, userDataPtr)		\
		(*userRoutine)(err, item, (Ptr)userDataPtr)
#define NewCyberResolveCompletionProc(userRoutine)		\
		(CyberResolveCompletionUPP)(userRoutine)
#endif

// CyberNotebookAddressProcPtr

enum {
	uppCyberNotebookAddressProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(CDAddressField)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(Ptr)))
		 | STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(Ptr)))
};

#if GENERATINGCFM

	typedef UniversalProcPtr CyberNotebookAddressUPP;
	
	#define CallCyberNotebookAddressProc(userRoutine, whichField, items, userDataPtr)		\
			CallUniversalProc((UniversalProcPtr)userRoutine, uppCyberNotebookAddressProcInfo, whichField, items, userDataPtr)
	#define NewCyberNotebookAddressProc(userRoutine)		\
			(CyberNotebookAddressUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppCyberNotebookAddressProcInfo, GetCurrentArchitecture())

#else

	typedef CyberNotebookAddressProcPtr CyberNotebookAddressUPP;
	
	#define CallCyberNotebookAddressProc(userRoutine, whichField, items, userDataPtr)		\
			(*userRoutine)(whichField, items, (Ptr)userDataPtr)
	#define NewCyberNotebookAddressProc(userRoutine)		\
			(CyberNotebookAddressUPP)(userRoutine)

#endif

// CyberDownloadCompletionProcPtr

enum {
	uppCyberDownloadCompletionProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(CyberItem*)))
		 | STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(CDDownloadEvent)))
		 | STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(FSSpec*)))
		 | STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(Ptr)))
};

#if GENERATINGCFM
typedef UniversalProcPtr CyberDownloadCompletionUPP;

#define CallCyberDownloadCompletionProc(userRoutine, ev, item, event, fsspec, userData)		\
		CallUniversalProc((UniversalProcPtr)userRoutine, uppCyberDownloadCompletionProcInfo, ev, item, event, fsspec, userData)
#define NewCyberDownloadCompletionProc(userRoutine)		\
		(CyberDownloadCompletionUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppCyberDownloadCompletionProcInfo, GetCurrentArchitecture())
#else
typedef CyberDownloadCompletionProcPtr CyberDownloadCompletionUPP;

#define CallCyberDownloadCompletionProc(userRoutine, ev, item, event, fsspec, userData)		\
		(*userRoutine)(ev, item, event, fsspec, (Ptr)userData)
#define NewCyberDownloadCompletionProc(userRoutine)		\
		(CyberDownloadCompletionUPP)(userRoutine)
#endif



// CyberMenuDataDestructorProcPtr

enum {
	uppCyberMenuDataDestructorProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void*)))
};

#if GENERATINGCFM
typedef UniversalProcPtr CyberMenuDataDestructorUPP;

#define CallCyberMenuDataDestructorProc(userRoutine, menuData)		\
		CallUniversalProc((UniversalProcPtr)userRoutine, uppCyberMenuDataDestructorProcInfo, menuData)
#define NewCyberMenuDataDestructorProc(userRoutine)		\
		(CyberMenuDataDestructorUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppCyberMenuDataDestructorProcInfo, GetCurrentArchitecture())
#else
typedef CyberMenuDataDestructorProcPtr CyberMenuDataDestructorUPP;

#define CallCyberMenuDataDestructorProc(userRoutine, menuData)		\
		(*userRoutine)(menuData)
#define NewCyberMenuDataDestructorProc(userRoutine)		\
		(CyberMenuDataDestructorUPP)(userRoutine)
#endif


// ParamDestructorProcPtr

enum {
	uppParamDestructorProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Environment*)))
		 | STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(void*)))
};

#if GENERATINGCFM
typedef UniversalProcPtr ParamDestructorUPP;

#define CallParamDestructorProc(userRoutine, ev, param)		\
		CallUniversalProc((UniversalProcPtr)userRoutine, uppParamDestructorProcInfo, ev, param)
#define NewParamDestructorProc(userRoutine)					\
		(ParamDestructorUPP) NewRoutineDescriptor((ProcPtr)userRoutine, uppParamDestructorProcInfo, GetCurrentArchitecture())
#else
typedef ParamDestructorProcPtr ParamDestructorUPP;

#define CallParamDestructorProc(userRoutine, ev, param)		\
		(*userRoutine)(ev, (void*)param)
#define NewParamDestructorProc(userRoutine)					\
		(ParamDestructorUPP)(userRoutine)
#endif


#endif